<template>
  <div>
    <h1 class="mb-3">Let’s start with the basics.</h1>
    <p class="text-base mb-6">This information helps your doctor determine if you’re eligible for treatment.</p>
    <div class="grid gap-y-3 mb-5">
      <div class="text-base flex items-center relative">
        <span class="mr-1">Sex Assigned at Birth</span>
        <img
          class="tooltip-target w-4 h-4 cursor-pointer"
          src="@/assets/img/icons/info.png"
          alt="info"
          @click="displayTooltip = !displayTooltip"
        >
        <transition name="fast-fade">
          <div
            class="z-10 top-full transform translate-y-2 absolute bg-black rounded-lg py-5 pl-5 pr-14 text-base text-white"
            v-if="displayTooltip"
          >
            <span>Your sex assigned at birth is needed by your doctor for making medical decisions.</span>
            <img
              class="w-4 h-4 absolute right-5 top-5 cursor-pointer"
              src="@/assets/img/icons/close.png"
              alt="close"
              @click="displayTooltip = false"
            >
          </div>
        </transition>
      </div>
      <TwoSideInput
        first-value="Male"
        second-value="Female"
        v-model="selected.gender"
        :error-message="getErrorMessage('gender')"
      />
      <TextInput
        placeholder="MM/DD/YYYY"
        label="Birthdate"
        v-model="selected.birthdate"
        :error-message="getErrorMessage('birthdate')"
      />
      <TextInput
        label="Zipcode"
        v-model="selected.zipcode"
        :error-message="getErrorMessage('zipcode')"
      />
      <TextInput
        label="Mobile Phone Number"
        v-model="selected.phone"
        :error-message="getErrorMessage('phone')"
      />
    </div>
    <checkbox-input
      class="mb-7"
      :transparent="true"
      :value="checkboxSelected"
      :input-value="true"
      @input="handleCheckboxInput"
      :error-message="!checkboxSelected.length && $v.$dirty ? 'Please fill this field' : null"
    >
        <span>
          I agree to the <a class="underline" href="#">terms</a>, <a class="underline" href="#">privacy policy</a> and consent to <a
          class="underline" href="#">telehealth</a>
        </span>
    </checkbox-input>
    <CommonBtn
      @click="handleClick"
      text="Next"
    />
  </div>
</template>

<script>
import TwoSideInput from "@/components/inputs/TwoSideInput";
import TextInput from "@/components/inputs/TextInput";
import CheckboxInput from "@/components/inputs/CheckboxInput";
import {answersMixin, checkboxMixin, referMixin} from "@/utils/mixins";
import CommonBtn from "@/components/common/CommonBtn";
import {required} from 'vuelidate/lib/validators'

const dateRegex = /^\d{2}\/\d{2}\/\d{4}$/g

const dateValidator = value => {
  return Boolean(String(new Date(value)) !== 'Invalid Date' && String(value).match(dateRegex))
}

export default {
  mixins: [checkboxMixin, answersMixin, referMixin],
  name: "TheBasics1",
  components: {CommonBtn, CheckboxInput, TextInput, TwoSideInput},
  watch: {
    selected: {
      handler(newVal) {
        this.setAnswer(this.answersKeys.THE_BASICS, newVal, 'stage_1')
      },
      deep: true
    }
  },
  validations: {
    selected: {
      gender: {required},
      birthdate: {required, dateValidator},
      zipcode: {required},
      phone: {required},
    },
    checkboxSelected: {required},
  },
  data() {
    return {
      selected: {
        gender: null,
        birthdate: '',
        zipcode: '',
        phone: '',
      },
      checkHandler: () => {
        const value = this.checkboxSelected.length ? this.checkboxSelected[0] : null
        this.setAnswer(this.answersKeys.THE_BASICS, value, 'termsAgree')
      },
      displayTooltip: false,
    }
  },
  methods: {
    handleClick() {
      this.$v.$touch()
      if (!this.$v.$invalid) {
        this.checkForRefer()
      }
    },
    checkForRefer() {
      const fullYears = new Date().getFullYear() - new Date(this.selected.birthdate).getFullYear()
      if (fullYears < 18) {
        this.setRefer('Sorry!', 'It appears you are too young to qualify for prescription ED medication. Patients must be 18 and over to obtain the medications REX MD provides.')

      } else if (fullYears > 75) {
        this.setRefer('Sorry!', 'It appears you are not a good candidate for receiving prescription ED medication through REX MD. Seniors tend to have underlying conditions that could put them at risk of adverse reactions. ')

      } else if (this.selected.gender === 'Female') {
        this.setRefer('Sorry!', 'It appears you are not a good candidate for prescription ED medication. These medications are only effective on individuals assigned male at birth. ')
      }

      if (this.refer) return

      this.$emit('nextStage')
    },
    getErrorMessage(field) {
      let msg = null
      const isInvalid = this.$v.selected[field].$invalid && this.$v.selected[field].$dirty

      if (isInvalid) {
        msg = 'Please fill this field'

        if (field === 'gender') {
          msg = 'Please select gender'
        }



        if (field === 'birthdate' && !this.$v.selected[field].dateValidator) {
          msg = 'Enter valid date'
        }
      }


      return msg
    }
  }
}
</script>

<style>

</style>
